from flask import Flask, jsonify
from pymongo import MongoClient
from pymongo.server_api import ServerApi

app = Flask(__name__)

# Default route
@app.route('/')
def home():
    return jsonify(message='Welcome to the API!')


# Example endpoint
@app.route('/api/data', methods=['GET'])
def get_data():
    data = {'example_data': [1, 2, 3, 4, 5]}
    return jsonify(data)



# Initialise database connection
def init_db():
    # Initialise database connection
    uri = "mongodb+srv://icemapcluster.i02epob.mongodb.net/?authSource=%24external&authMechanism=MONGODB-X509&retryWrites=true&w=majority"
    
    try:
        client = MongoClient(uri,
                            tls=True,
                            tlsCertificateKeyFile='server/X509-cert-2722575229130410888.pem',
                            server_api=ServerApi('1'))

        db = client['IceMapDatabase']
        collection = db['GeoDataCollection']

        # Ping to check connection
        client.admin.command('ping')

        print("Connected to MongoDB!")

    except ConnectionFailure as e:
        print(f"Failed to connect to MongoDB: {e}")

if __name__ == "__main__":
    init_db()